/* Copyright (C) 2006 - 2009 ScriptDev2 <https://scriptdev2.svn.sourceforge.net/>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* ScriptData
SDName: Icecrown
SD%Complete: 100
SDComment: Quest support: 12807
SDCategory: Icecrown
EndScriptData */

/* ContentData
npc_arete
EndContentData */

#include "precompiled.h"

/*######
## npc_arete
######*/

#define GOSSIP_ARETE_ITEM1 "Lord-Commander, I would hear your tale."
#define GOSSIP_ARETE_ITEM2 "<You nod slightly but do not complete the motion as the Lord-Commander narrows his eyes before he continues.>"
#define GOSSIP_ARETE_ITEM3 "I thought that they now called themselves the Scarlet Onslaught?"
#define GOSSIP_ARETE_ITEM4 "Where did the grand admiral go?"
#define GOSSIP_ARETE_ITEM5 "That's fine. When do I start?"
#define GOSSIP_ARETE_ITEM6 "Let's finish this!"
#define GOSSIP_ARETE_ITEM7 "That's quite a tale, Lord-Commander."

enum
{
    GOSSIP_TEXTID_ARETE1        = 13525,
    GOSSIP_TEXTID_ARETE2        = 13526,
    GOSSIP_TEXTID_ARETE3        = 13527,
    GOSSIP_TEXTID_ARETE4        = 13528,
    GOSSIP_TEXTID_ARETE5        = 13529,
    GOSSIP_TEXTID_ARETE6        = 13530,
    GOSSIP_TEXTID_ARETE7        = 13531,

    QUEST_THE_STORY_THUS_FAR    = 12807
};

bool GossipHello_npc_arete(Player* pPlayer, Creature* pCreature)
{
    if (pCreature->isQuestGiver())
        pPlayer->PrepareQuestMenu(pCreature->GetGUID());

    if (pPlayer->GetQuestStatus(QUEST_THE_STORY_THUS_FAR) == QUEST_STATUS_INCOMPLETE)
    {
        pPlayer->ADD_GOSSIP_ITEM(GOSSIP_ICON_CHAT, GOSSIP_ARETE_ITEM1, GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF+1);
        pPlayer->SEND_GOSSIP_MENU(GOSSIP_TEXTID_ARETE1, pCreature->GetGUID());
        return true;
    }

    pPlayer->SEND_GOSSIP_MENU(pCreature->GetNpcTextId(), pCreature->GetGUID());
    return true;
}

bool GossipSelect_npc_arete(Player* pPlayer, Creature* pCreature, uint32 uiSender, uint32 uiAction)
{
    switch(uiAction)
    {
        case GOSSIP_ACTION_INFO_DEF+1:
            pPlayer->ADD_GOSSIP_ITEM(GOSSIP_ICON_CHAT, GOSSIP_ARETE_ITEM2, GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF + 2);
            pPlayer->SEND_GOSSIP_MENU(GOSSIP_TEXTID_ARETE2, pCreature->GetGUID());
            break;
        case GOSSIP_ACTION_INFO_DEF+2:
            pPlayer->ADD_GOSSIP_ITEM(GOSSIP_ICON_CHAT, GOSSIP_ARETE_ITEM3, GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF + 3);
            pPlayer->SEND_GOSSIP_MENU(GOSSIP_TEXTID_ARETE3, pCreature->GetGUID());
            break;
        case GOSSIP_ACTION_INFO_DEF+3:
            pPlayer->ADD_GOSSIP_ITEM(GOSSIP_ICON_CHAT, GOSSIP_ARETE_ITEM4, GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF + 4);
            pPlayer->SEND_GOSSIP_MENU(GOSSIP_TEXTID_ARETE4, pCreature->GetGUID());
            break;
        case GOSSIP_ACTION_INFO_DEF+4:
            pPlayer->ADD_GOSSIP_ITEM(GOSSIP_ICON_CHAT, GOSSIP_ARETE_ITEM5, GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF + 5);
            pPlayer->SEND_GOSSIP_MENU(GOSSIP_TEXTID_ARETE5, pCreature->GetGUID());
            break;
        case GOSSIP_ACTION_INFO_DEF+5:
            pPlayer->ADD_GOSSIP_ITEM(GOSSIP_ICON_CHAT, GOSSIP_ARETE_ITEM6, GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF + 6);
            pPlayer->SEND_GOSSIP_MENU(GOSSIP_TEXTID_ARETE6, pCreature->GetGUID());
            break;
        case GOSSIP_ACTION_INFO_DEF+6:
            pPlayer->ADD_GOSSIP_ITEM(GOSSIP_ICON_CHAT, GOSSIP_ARETE_ITEM7, GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF + 7);
            pPlayer->SEND_GOSSIP_MENU(GOSSIP_TEXTID_ARETE7, pCreature->GetGUID());
            break;
        case GOSSIP_ACTION_INFO_DEF+7:
            pPlayer->CLOSE_GOSSIP_MENU();
            pPlayer->AreaExploredOrEventHappens(QUEST_THE_STORY_THUS_FAR);
            break;
    }

    return true;
}

//###########QUEST BANSHEE'S REVANGE#############
//Comment: Need Vehicles!
//defines quest 13142
uint32 balargarde_event = 0;

enum
{
 SAY_EVN01         =-1544071,
 SAY_EVN02         =-1544072,
 SAY_EVN03         =-1544073,
 SAY_EVN04         =-1544074,
 SAY_EVN05         =-1544075,
 SAY_EVN06         =-1544076,
 SAY_EVN07         =-1544077,
 SAY_EVN08         =-1544078,
 SAY_EVN09         =-1544079,
 SAY_EVN10         =-1544080,
 SAY_EVN11         =-1544081,
 SAY_EVN12         =-1544082,
 SAY_EVN13         =-1544083,
 SAY_EVN14         =-1544084,
 SAY_EVN15         =-1544085,
 SAY_EVN16         =-1544086,
 SAY_EVN17         =-1544087
};

struct MANGOS_DLL_DECL npc_vardmadraAI : public ScriptedAI
{
   npc_vardmadraAI(Creature *c) : ScriptedAI(c) {Reset();
}
Creature* escortbal;
uint32 phasetim;
uint32 Step;
Creature* lichking;
Creature* vardmadra;
Creature* balargarde;
uint32 Pause;

  void Reset() 
   {
     Pause = 0;
     Step = 1;
     Pause =  0;
   }

void UpdateAI(const uint32 diff)
   {

          if(balargarde_event == 1)
              {
                switch(Step)
	   {
	   case 1:
                           vardmadra = m_creature;
                           vardmadra->SetSpeed(MOVE_WALK,5.0f);
                           vardmadra->canFly();
                           vardmadra->GetMotionMaster()->MovePoint(0, 7095.09f,4326.43f,881.427f);
                           ++Step;
                           phasetim = 7000;
                           break;
	   case 3:
                          DoScriptText(SAY_EVN01, vardmadra);
                          ++Step;
                          phasetim = 2000;
                          break;
               case 5:
                          balargarde = m_creature->SummonCreature(31016,7100.888f,4424.06f,846.20f,1.37f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,920000);
                          balargarde->Mount(27043);
                          balargarde->setFaction(35);
                          balargarde->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                          balargarde->CastSpell(balargarde, 201, false);
                          balargarde->GetMotionMaster()->MovePoint(0, 7094.72f,4400.99f,889.4311f);
                          ++Step;
                          phasetim = 5000;
                          break;
               case 7:
                          balargarde->GetMotionMaster()->MovePoint(0, 7080.51f,4356.35f,882.74f);
                          ++Step;
                          phasetim = 7000;
                          break;
               case 9:
                          DoScriptText(SAY_EVN02, balargarde);
                          ++Step;
                          phasetim = 7000;
                          break;

               case 11:
                          DoScriptText(SAY_EVN03, vardmadra);
                          ++Step;
                          phasetim = 8000;
                          break;
               case 13:
                          DoScriptText(SAY_EVN04, balargarde);
                          ++Step;
                          phasetim = 5000;
                          break;
               case 15:
                          balargarde->Unmount();
                          balargarde->GetMap()->CreatureRelocation(balargarde, 7079.093,4350.977,871.4411, 0);
                          balargarde->SendMonsterMove(7079.093,4350.977,871.4411, 0, MONSTER_MOVE_NONE, 0);
                          balargarde->LoadEquipment(685);
                          ++Step;
                          phasetim = 1000;
                          break;
               case 17:
                          DoScriptText(SAY_EVN05, balargarde);
                          ++Step;
                          phasetim = 9000;
                          break;
               case 19:
                          balargarde->HandleEmoteCommand(15);
                          ++Step;
                          phasetim = 2000;
                          break;
               case 21:
                          balargarde->setFaction(14);
                          Pause = 1;
                          Step = 49;
                          break;
               }

           if (phasetim <= diff)
	   {
		   ++Step;
		   phasetim = 20000000;
	   } phasetim -= diff;

            } else return;

    if (Pause == 1)
      {
         if (balargarde->isDead())
          {
            switch(Step)
                {
               case 49:
                          if (Creature* pLich = GetClosestCreatureWithEntry(m_creature, 28498, 150.0f)) 
                            {
                              lichking = pLich;
                            }
                          lichking->SetUInt64Value(UNIT_FIELD_TARGET, balargarde->GetGUID());
                          DoScriptText(SAY_EVN16, lichking);
                          ++Step;
                          phasetim = 8000;
                          break;
               case 51:
                          DoScriptText(SAY_EVN17, lichking);
                          ++Step;
                          phasetim = 8000;
                          break;
               case 53:
                          lichking->SetVisibility(VISIBILITY_OFF);
                          lichking->DealDamage(lichking, lichking->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                          ++Step;
                          phasetim = 1000;
                          break;
               case 55:                      
                          balargarde->SetVisibility(VISIBILITY_OFF);
                          balargarde->DealDamage(balargarde, balargarde->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                          vardmadra->ForcedDespawn();
                          balargarde_event = 0;
                          Pause = 0;
                          Step = 1;
                          break;
        }

           if (phasetim <= diff)
	   {
		   ++Step;
		   phasetim = 20000000;
	   } phasetim -= diff;

    } else return;
} else return;

        }
};

CreatureAI* GetAI_npc_vardmadra(Creature *_Creature)
{
    npc_vardmadraAI* vardmadraAI = new npc_vardmadraAI(_Creature);
    return (CreatureAI*)vardmadraAI;
};

struct MANGOS_DLL_DECL npc_balargardeAI : public ScriptedAI
{
   npc_balargardeAI(Creature *c) : ScriptedAI(c) {Reset();
}

uint32 Step;
uint32 FrostBolt_Timer;
uint32 Blizzard_Timer;
uint32 Leap_Timer;
uint32 Whirlwind_Timer;
uint32 phasetim;
Creature* lichking;
Creature* vardmadra;
Creature* balargarde;

   void Reset() 
   {
     Step = 23;
     phasetim = 20000;
     FrostBolt_Timer = 7300;
     Blizzard_Timer = 19300;
     Leap_Timer = 31300;
     Whirlwind_Timer = 26300;
   }

   void UpdateAI(const uint32 diff)
   {

    if (Creature* pVardmadra = GetClosestCreatureWithEntry(m_creature, 31029, 150.0f)) 
         {
          if(((npc_vardmadraAI*)pVardmadra->AI())->Pause == 1)
             {
         DoMeleeAttackIfReady();

if (FrostBolt_Timer < diff)
        {
            if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(target,15043);

            FrostBolt_Timer = 7300;
        }else FrostBolt_Timer -= diff;

if (Blizzard_Timer < diff)
        {
            if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(target,61085);

            Blizzard_Timer = 19300;
        }else Blizzard_Timer -= diff;

if (Leap_Timer < diff)
        {
            if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(target,60108);

            Leap_Timer = 27300;
        }else Leap_Timer -= diff;

if (Whirlwind_Timer < diff)
        {
            if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(m_creature,61076);

            Whirlwind_Timer = 22300;
        }else Whirlwind_Timer -= diff;
       }
   }

if (m_creature->GetHealth()*100 / m_creature->GetMaxHealth() < 50)
    {     

             switch(Step)
             {
               case 23:
                          if (Creature* pVardmadra = GetClosestCreatureWithEntry(m_creature, 31029, 150.0f)) 
                            {
                              (((npc_vardmadraAI*)pVardmadra->AI())->Pause = 0);
                              vardmadra = pVardmadra;
                            }
                          balargarde = m_creature;
                          lichking = m_creature->SummonCreature(28498,7089.565f,4385.47f,872.3707f,4.48f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,920000);
                          lichking->SetUInt64Value(UNIT_FIELD_TARGET, balargarde->GetGUID());
                          balargarde->InterruptNonMeleeSpells(false);
                          balargarde->GetMotionMaster()->Clear(false);
                          balargarde->SetFlag(UNIT_FIELD_FLAGS, UNIT_FLAG_NON_ATTACKABLE);
                          balargarde->HandleEmoteCommand(68);
                          balargarde->SetUInt64Value(UNIT_FIELD_TARGET, lichking->GetGUID());
                          vardmadra->SetStandState(UNIT_STAND_STATE_KNEEL);
                          vardmadra->SetUInt64Value(UNIT_FIELD_TARGET, lichking->GetGUID());
                          DoScriptText(SAY_EVN06, balargarde);
                          ++Step;
                          phasetim = 5000;
                          break;
               case 25:
                          DoScriptText(SAY_EVN07, lichking);
                          lichking->HandleEmoteCommand(25);
                          ++Step;
                          phasetim = 6000;
                          break;
               case 27:
                          lichking->SetUInt64Value(UNIT_FIELD_TARGET, vardmadra->GetGUID());
                          DoScriptText(SAY_EVN08, lichking);
                          lichking->SetSpeed(MOVE_WALK,2.0f);
                          lichking->GetMotionMaster()->MovePoint(0, 7093.713f,4329.212f,871.467f);
                          ++Step;
                          phasetim = 13000;
                          break;
               case 29:
                          DoScriptText(SAY_EVN09, vardmadra);
                          ++Step;
                          phasetim = 4000;
                          break;
               case 31:
                          DoScriptText(SAY_EVN10, lichking);
                          ++Step;
                          phasetim = 5000;
                          break;
               case 33:
                          lichking->HandleEmoteCommand(37);
                          DoScriptText(SAY_EVN11, vardmadra);
                          ++Step;
                          phasetim = 3000;
                          break;
               case 35:
                          vardmadra->SetStandState(UNIT_STAND_STATE_DEAD);
                          ++Step;
                          phasetim = 3000;
                          break;
               case 37:
                          lichking->HandleEmoteCommand(11);
                          lichking->PlayDirectSound(14820);
                          ++Step;
                          phasetim = 3000;
                          break;
               case 39:
                          lichking->SetUInt64Value(UNIT_FIELD_TARGET, balargarde->GetGUID());
                          lichking->HandleEmoteCommand(25);
                          DoScriptText(SAY_EVN12, lichking);
                          ++Step;
                          phasetim = 6000;
                          break;
               case 41:
                          DoScriptText(SAY_EVN13, balargarde);
                          ++Step;
                          phasetim = 3000;
                          break;
               case 43:
                          DoScriptText(SAY_EVN14, lichking);
                          ++Step;
                          phasetim = 5000;
                          break;
               case 45:
                          lichking->HandleEmoteCommand(15);
                          ++Step;
                          phasetim = 4000;
                          break;
               case 47:
                          DoScriptText(SAY_EVN15, balargarde);
                          balargarde->RemoveFlag(UNIT_FIELD_FLAGS, UNIT_FLAG_NON_ATTACKABLE);
                          balargarde->SetUInt64Value(UNIT_FIELD_TARGET, 0);                        
                          balargarde->GetMotionMaster()->MoveIdle();
                          balargarde->GetMotionMaster()->MoveChase(balargarde->getVictim());
                          if (Creature* pVardmadra = GetClosestCreatureWithEntry(m_creature, 31029, 150.0f)) 
                            {
                              (((npc_vardmadraAI*)pVardmadra->AI())->Pause = 1);
                            }
                          ++Step;
                          phasetim = 2000;
                          break;
                      }                      
       }   else return;

           if (phasetim <= diff)
	   {
		   ++Step;
		   phasetim = 20000000;
	   } phasetim -= diff;
  }
};

CreatureAI* GetAI_npc_balargarde(Creature *_Creature)
{
    npc_balargardeAI* balargardeAI = new npc_balargardeAI(_Creature);
    return (CreatureAI*)balargardeAI;
};


bool GOHello_horn(Player* pPlayer, GameObject* pGo)
{

 if(balargarde_event == 0)
   if (pPlayer->GetQuestStatus(13142) == QUEST_STATUS_INCOMPLETE)
        {                  
                           pPlayer->SummonCreature(31029,7132.894f,4272.786f,898.20f,1.37f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,920000);
                           balargarde_event = 1;
        }

    return false;
};

//#################QUEST TIRION'S GAMBIT#########################

enum
{
  NPC_TIRION_FORDRING                     = 32239,
  NPC_LICH_KING                                 = 32184,
  NPC_INKVISITOR                                = 32272,
  NPC_DARION_MOGRAINE                  = 32312,
  NPC_KOLTIRA                                    = 32311,
  NPC_THASSARIAN                             = 32310,
  NPC_TIRION_ESCORT                        = 32241,
  NPC_UNHOLY_MAN                           = 32175,
  NPC_DEATH_KNIGHT                         = 32309,
  NPC_QUEST_CREDIT                         = 32648,

  EQUIP_HIGHLORD_TIRION_FORDRING    = 13262,

  SPELL_FURY_LK                               = 60536,

  GO_FROZEN_HEART                          = 193794,
  GO_ESCAPE_PORTAL                       = 193941
};

struct MANGOS_DLL_DECL npc_tirionTGAI : public ScriptedAI
{
   npc_tirionTGAI(Creature *c) : ScriptedAI(c) {Reset();
}

bool MonahDead;
bool TirionDown;
GameObject* Heart;
Creature* lichking;
Creature* mograine;
Creature* escort01;
Creature* escort02;
Creature* escort03;
Creature* inkvisitor;
Creature* Monah01;
Creature* Monah02;
Creature* Monah03;
Creature* DeathKnight;
Creature* koltira;
Creature* credit;
uint32 Phase;
uint32 Phasetim;
bool Start_Event;
Unit* Hero_Faction;

  void Reset() 
   {
     m_creature->SetFlag(UNIT_NPC_FLAGS, UNIT_NPC_FLAG_QUESTGIVER);
     m_creature->SetFlag(UNIT_NPC_FLAGS, UNIT_NPC_FLAG_GOSSIP);
     MonahDead = false;
     TirionDown = false;
     Hero_Faction;
     Start_Event = false;
     Phase = 1;
     Phasetim = 1000;
    }

void UpdateAI(const uint32 diff)
   {
       if(Start_Event == false) return;
  
      switch(Phase)
           {
            case 1:
                 m_creature->RemoveFlag(UNIT_NPC_FLAGS, UNIT_NPC_FLAG_QUESTGIVER);
                 m_creature->RemoveFlag(UNIT_NPC_FLAGS, UNIT_NPC_FLAG_GOSSIP);
                 m_creature->MonsterSay("It is time. May the Light give us Strength.",LANG_UNIVERSAL,NULL);
                 if (Creature* pEscort = GetClosestCreatureWithEntry(m_creature, NPC_TIRION_ESCORT, 50.0f))
                      escort01 = pEscort;
                 escort01->UpdateEntry(30407, 0);
                 if (Creature* pEscort = GetClosestCreatureWithEntry(m_creature, NPC_TIRION_ESCORT, 50.0f))
                      escort02 = pEscort;
                 escort02->UpdateEntry(30407, 0);
                 if (Creature* pEscort = GetClosestCreatureWithEntry(m_creature, NPC_TIRION_ESCORT, 50.0f))
                      escort03 = pEscort;
                 escort01->UpdateEntry(NPC_TIRION_ESCORT, 0);
                 escort02->UpdateEntry(NPC_TIRION_ESCORT, 0);
                 escort01->GetMotionMaster()->MovePoint(0, 6236.877f,2657.029f,570.250f);
                 escort02->GetMotionMaster()->MovePoint(0, 6247.588f,2644.267f,570.250f);
                 escort03->GetMotionMaster()->MovePoint(0, 6250.729f,2654.770f,570.250f);
                 ++Phase;
                 Phasetim = 3000;
                 break;
            case 3:
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6244.514f,2653.304f,570.250f);
                 ++Phase;
                 Phasetim = 3000;
                 break;
            case 5:
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 escort01->GetMotionMaster()->MovementExpired(false);
                 escort02->GetMotionMaster()->MovementExpired(false);
                 escort03->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6238.080f,2637.720f,570.250f);
                 escort01->GetMotionMaster()->MovePoint(0, 6235.732f,2642.606f,570.250f);
                 escort02->GetMotionMaster()->MovePoint(0, 6243.474f,2631.626f,570.250f);
                 escort03->GetMotionMaster()->MovePoint(0, 6247.588f,2644.267f,570.250f);
                 ++Phase;
                 Phasetim = 5000;
                 break;
            case 7:
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 escort01->GetMotionMaster()->MovementExpired(false);
                 escort02->GetMotionMaster()->MovementExpired(false);
                 escort03->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6205.637f,2607.220f,570.250f);
                 escort01->GetMotionMaster()->MovePoint(0, 6206.382f,2615.784f,570.250f);
                 escort02->GetMotionMaster()->MovePoint(0, 6196.662f,2608.232f,570.250f);
                 escort03->GetMotionMaster()->MovePoint(0, 6206.591f,2604.310f,570.250f);
                 ++Phase;
                 Phasetim = 17000;
                 break;
            case 9:
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 escort01->GetMotionMaster()->MovementExpired(false);
                 escort02->GetMotionMaster()->MovementExpired(false);
                 escort03->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6190.103f,2637.606f,570.250f);
                 escort01->GetMotionMaster()->MovePoint(0, 6196.842f,2634.990f,570.250f);
                 escort02->GetMotionMaster()->MovePoint(0, 6187.880f,2632.062f,570.250f);
                 escort03->GetMotionMaster()->MovePoint(0, 6193.905f,2628.636f,570.250f);
                 ++Phase;
                 Phasetim = 17000;
                 break;
            case 11:               
                 m_creature->MonsterSay("Keep your heads down and follow my lead.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 2000;
                 break;
            case 13:               
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 escort01->GetMotionMaster()->MovementExpired(false);
                 escort02->GetMotionMaster()->MovementExpired(false);
                 escort03->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6180.998f,2657.858f,573.766f);
                 escort01->GetMotionMaster()->MovePoint(0, 6185.521f,2660.033f,574.110f);
                 escort02->GetMotionMaster()->MovePoint(0, 6176.338f,2655.563f,574.052f);
                 escort03->GetMotionMaster()->MovePoint(0, 6183.513f,2653.620f,572.971f);
                 ++Phase;
                 Phasetim = 10000;
                 break;
            case 15:  
                 escort01->GetMotionMaster()->MovementExpired(false);
                 escort02->GetMotionMaster()->MovementExpired(false);
                 escort03->GetMotionMaster()->MovementExpired(false);   
                 m_creature->GetMotionMaster()->MovePoint(0, 6144.981f,2736.049f,573.914f);
                 escort01->GetMotionMaster()->MovePoint(0, 6151.787f,2731.111f,573.914f);
                 escort02->GetMotionMaster()->MovePoint(0, 6142.698f,2727.231f,573.915f);
                 escort03->GetMotionMaster()->MovePoint(0, 6148.990f,2727.134f,573.914f);          
                 ++Phase;
                 Phasetim = 32000;
                 break;
            case 17:                                
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6163.32f,2746.957f,573.914f);
                 escort01->GetMotionMaster()->MovementExpired(false);
                 escort01->GetMotionMaster()->MovePoint(0, 6168.990f,2761.715f,573.915f);
                 escort02->GetMotionMaster()->MovementExpired(false);
                 escort02->GetMotionMaster()->MovePoint(0, 6172.088f,2763.098f,573.915f);
                 escort03->GetMotionMaster()->MovementExpired(false);
                 escort03->GetMotionMaster()->MovePoint(0, 6175.234f,2764.600f,573.915f);
                 ++Phase;
                 Phasetim = 9000;
                 break;
            case 19:                                
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6165.613f,2760.049f,573.914f);
                 ++Phase;
                 Phasetim = 7000;
                 break;
            case 21:                                              
                 if (Creature* pInkvisitor = GetClosestCreatureWithEntry(m_creature, NPC_INKVISITOR, 150.0f)) 
                 {
                 m_creature->SetUInt64Value(UNIT_FIELD_TARGET, pInkvisitor->GetGUID());
                 escort01->SetUInt64Value(UNIT_FIELD_TARGET, pInkvisitor->GetGUID());
                 escort02->SetUInt64Value(UNIT_FIELD_TARGET, pInkvisitor->GetGUID());
                 escort03->SetUInt64Value(UNIT_FIELD_TARGET, pInkvisitor->GetGUID());
                 }
                 m_creature->MonsterSay("Here it comes. Stand ready.",LANG_UNIVERSAL,NULL);
                 Monah01 = m_creature->SummonCreature(NPC_UNHOLY_MAN,6166.140f,2688.851f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,80000);
                 Monah02 = m_creature->SummonCreature(NPC_UNHOLY_MAN,6165.166f,2684.646f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,80000);
                 Monah03 = m_creature->SummonCreature(NPC_UNHOLY_MAN,6170.443f,2687.208f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,80000);
                 Monah01->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);
                 Monah02->GetMotionMaster()->MovePoint(0, 6132.520f,2753.841f,573.914f);
                 Monah03->GetMotionMaster()->MovePoint(0, 6138.576f,2757.051f,573.914f);
                 ++Phase;
                 Phasetim = 32000;
                 break;   
            case 23:                                              
                 Monah01->SetStandState(UNIT_STAND_STATE_KNEEL);
                 Monah02->SetStandState(UNIT_STAND_STATE_KNEEL);
                 Monah03->SetStandState(UNIT_STAND_STATE_KNEEL);  
                 ++Phase;
                 Phasetim = 2000;
                 break;   
            case 25:                                                               
                 if (GameObject* pHeart = GetClosestGameObjectWithEntry(m_creature, GO_FROZEN_HEART, 150.0f)) 
                 {      
                 Heart = pHeart;          
                 pHeart->SetRespawnTime(123);
                 }          
                 ++Phase;
                 Phasetim = 3000;
                 break;   
            case 27:                                                               
                 Monah01->MonsterSay("We lost many to the faceless ones my lord. But we succeeded in retrieving the heart of Nazaruk.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 4000;
                 break;   
            case 29:
                 Monah01->SetStandState(UNIT_STAND_STATE_STAND);
                 Monah02->SetStandState(UNIT_STAND_STATE_STAND);
                 Monah03->SetStandState(UNIT_STAND_STATE_STAND);  
                 ++Phase;
                 Phasetim = 2000;
                 break;   
            case 31:
                 Monah01->HandleEmoteCommand(2);
                 Monah02->HandleEmoteCommand(2);
                 Monah03->HandleEmoteCommand(2); 
                 ++Phase;
                 Phasetim = 2000;
                 break;   
            case 33:
                 Monah01->GetMotionMaster()->MovePoint(0, 6166.140f,2688.851f,573.914f);
                 Monah02->GetMotionMaster()->MovePoint(0, 6165.166f,2684.646f,573.914f);
                 Monah03->GetMotionMaster()->MovePoint(0, 6170.443f,2687.208f,573.914f);
                 m_creature->MonsterSay("Something wrong... I sense a dark presence.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 5000;
                 break;   
            case 35:
                 m_creature->MonsterSay("The Lich King is here. May the Light guide our blades.",LANG_UNIVERSAL,NULL);
                 lichking = m_creature->SummonCreature(NPC_LICH_KING,6166.140f,2688.851f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,480000);
                 lichking->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);
                 lichking->setFaction(35);
                 m_creature->SetUInt64Value(UNIT_FIELD_TARGET, lichking->GetGUID());
                 ++Phase;
                 Phasetim = 9000;
                 break;  
            case 37: 
                 Monah01->GetMotionMaster()->MovementExpired(false);
                 Monah02->GetMotionMaster()->MovementExpired(false);
                 Monah03->GetMotionMaster()->MovementExpired(false);
                 Monah01->GetMotionMaster()->MovePoint(0, 6133.294f,2691.485f,573.914f);
                 Monah02->GetMotionMaster()->MovePoint(0, 6133.294f,2691.485f,573.914f);
                 Monah03->GetMotionMaster()->MovePoint(0, 6133.294f,2691.485f,573.914f);
                 ++Phase;
                 Phasetim = 25000;
                 break;  
             case 39:
                 lichking->SetUInt64Value(UNIT_FIELD_TARGET, m_creature->GetGUID());
                 lichking->MonsterSay("Parish mortals. I sensed yours soul many time ago.",LANG_UNIVERSAL,NULL);
                 m_creature->SetUInt32Value(UNIT_VIRTUAL_ITEM_SLOT_ID + 0, uint32(EQUIP_HIGHLORD_TIRION_FORDRING));
                 m_creature->GetMotionMaster()->MovePoint(0, 6167.601f,2757.219f,573.914f);
                 ++Phase;
                 Phasetim = 2000;
                 break;   
             case 41:
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6157.914f,2755.602f,573.914f);
                 ++Phase;
                 Phasetim = 3000;
                 break;   
             case 43:
                 m_creature->GetMotionMaster()->MovementExpired(false);
                 m_creature->GetMotionMaster()->MovePoint(0, 6143.597f,2757.256f,573.914f);
                 lichking->MonsterSay("I must condess... You were not anogether enexpiced. I hope you find your final resuing place.. to your liking.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 14000;
                 break;   
             case 45:
                 m_creature->MonsterSay("Your sound a little confident. I specialy considering the way our last encounter ended.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 5000;
                 break;   
             case 47:
                 lichking->MonsterSay("Last time we met, you had the advantage of fighting on holy ground. You'll find that situation has been... reversed.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 11000;
                 break;   
             case 49:
                 m_creature->MonsterSay("That might be, but I don't need to stand on holy ground to run that disembodled heart of yours with the Ashbringer.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 6000;
                 break;   
             case 51:
                 lichking->MonsterSay("I call your bluff. You're a paladin after all. Your obsession with redemption goes beyond the inare.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 8000;
                 break;   
             case 53:
                 lichking->MonsterSay("You surely woulds't destroy humanity's only chance to redeem its most wayward son. You'd sooner diel.",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 3000;
                 break;   
             case 55:
                 m_creature->MonsterSay("The heart... the last remaining vesilge of your humanity. I had to stop it from being destroyed. I had to see for my self. And at last I'm sure...",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 16000;
                 break;   
             case 57:
                 m_creature->MonsterSay("Only shadows from the past remain. There's  nothing left to redeem!",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 4000;
                 break;  
             case 59:
                 lichking->SetUInt64Value(UNIT_FIELD_TARGET, 0);
                 m_creature->SetUInt64Value(UNIT_FIELD_TARGET, 0);
                 m_creature->SetSpeed(MOVE_RUN, 3.0f);
                 m_creature->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 m_creature->GetMotionMaster()->MovePoint(0, 6130.473f,2762.259f,573.914f);
                 ++Phase;
                 Phasetim = 600;
                 break;  
             case 61:
                 m_creature->GetMotionMaster()->Clear(false);
                 m_creature->GetMotionMaster()->MoveIdle();
                 m_creature->StopMoving();
                 DoCast(m_creature,42904);
                 ++Phase;
                 Phasetim = 700;
                 break;
             case 63:    
                 DoCast(m_creature,60484);
                 ++Phase;
                 Phasetim = 500;
                 break;
             case 65:
                 m_creature->DealDamage(m_creature, m_creature->GetMaxHealth() - 1,NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 if (Creature* pInkvisitor = GetClosestCreatureWithEntry(m_creature, NPC_INKVISITOR, 150.0f)) 
                 {
                 pInkvisitor->DealDamage(pInkvisitor, pInkvisitor->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 }
                 m_creature->SetStandState(UNIT_STAND_STATE_DEAD);
                 lichking->DealDamage(lichking, lichking->GetMaxHealth() - 200000,NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 lichking->GetMap()->CreatureRelocation(lichking, 6130.926, 2743.355, 573.914, 0.537);
                 lichking->SendMonsterMove(6130.926, 2743.355, 573.914, 0.537, MONSTER_MOVE_NONE, 0);
                 ++Phase;
                 Phasetim = 500;
                 break;
             case 67:
                 lichking->GetMotionMaster()->MovePoint(0, 6131.531f,2743.784f,573.914f);
                 lichking->SetStandState(UNIT_STAND_STATE_KNEEL);
                 lichking->MonsterSay("Arrrrhhhhhhhh....",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 500;
                 break;
             case 69:
                 escort01->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 escort01->GetMotionMaster()->MovePoint(0, 6137.778f,2759.621f,573.914f);
                 escort02->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 escort02->GetMotionMaster()->MovePoint(0, 6128.400f,2757.948f,573.914f);
                 escort03->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 escort03->GetMotionMaster()->MovePoint(0, 6132.821f,2765.189f,573.914f);
                 ++Phase;
                 Phasetim = 3000;
                 break;
             case 71:
                 escort01->SetUInt64Value(UNIT_FIELD_TARGET, lichking->GetGUID());
                 escort02->SetUInt64Value(UNIT_FIELD_TARGET, lichking->GetGUID());
                 escort03->SetUInt64Value(UNIT_FIELD_TARGET, lichking->GetGUID());
                 escort01->MonsterSay("Tirion's down. Defend him with your lives",LANG_UNIVERSAL,NULL);
                 escort01->SetUInt32Value(UNIT_NPC_EMOTESTATE, EMOTE_STATE_READY2H);
                 escort02->SetUInt32Value(UNIT_NPC_EMOTESTATE, EMOTE_STATE_READY2H);
                 escort03->SetUInt32Value(UNIT_NPC_EMOTESTATE, EMOTE_STATE_READY2H);
                 ++Phase;
                 Phasetim = 3000;
                 break;
             case 73:
                 lichking->MonsterSay("You... Will pay for this old man. Slay the all...",LANG_UNIVERSAL,NULL);
                 ++Phase;
                 Phasetim = 3000;
                 break;
             case 75:
                 TirionDown = true;
                 ++Phase;
                 Phasetim = 6000;
                 break;
             case 77:
                 mograine = m_creature->SummonCreature(NPC_DARION_MOGRAINE,6164.402f,2694.072f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,120000);
                 mograine->setFaction(Hero_Faction->getFaction());
                 mograine->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 koltira = m_creature->SummonCreature(NPC_KOLTIRA,6161.058f,2692.482f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,120000);
                 koltira->setFaction(Hero_Faction->getFaction()); 
                 koltira->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 mograine->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);      
                 koltira->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);  
                 DeathKnight = m_creature->SummonCreature(NPC_DEATH_KNIGHT,6162.911f,2688.551f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,120000);   
                 DeathKnight->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 DeathKnight->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);     
                 DeathKnight->setFaction(Hero_Faction->getFaction());   
                 DeathKnight = m_creature->SummonCreature(NPC_DEATH_KNIGHT,6165.741f,2689.889f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,120000);   
                 DeathKnight->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 DeathKnight->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);     
                 DeathKnight->setFaction(Hero_Faction->getFaction());   
                 DeathKnight = m_creature->SummonCreature(NPC_DEATH_KNIGHT,6169.457f,2691.660f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,120000);
                 DeathKnight->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);   
                 DeathKnight->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);     
                 DeathKnight->setFaction(Hero_Faction->getFaction());   
                 DeathKnight = m_creature->SummonCreature(NPC_DEATH_KNIGHT,6168.437f,2687.293f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,120000);   
                 DeathKnight->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 DeathKnight->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);     
                 DeathKnight->setFaction(Hero_Faction->getFaction());  
                 ++Phase;
                 Phasetim = 56000;
                 break;
             case 79:
                 mograine->setFaction(35);
                 mograine->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                 mograine->GetMotionMaster()->MovePoint(0, 6133.930f,2758.642f,573.914f);
                 if (GameObject* pPortal = GetClosestGameObjectWithEntry(m_creature, GO_ESCAPE_PORTAL, 150.0f)) 
                 {                
                 pPortal->SetRespawnTime(30);
                 }   
                 mograine->SetUInt32Value(UNIT_NPC_EMOTESTATE, EMOTE_STATE_READY1H);
                 credit = m_creature->SummonCreature(NPC_QUEST_CREDIT,6133.930f,2758.642f,573.914f,1.987f,TEMPSUMMON_TIMED_OR_DEAD_DESPAWN,120000);
                 Hero_Faction->DealDamage(credit, credit->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 ++Phase;
                 Phasetim = 4000;
                 break;
             case 81:
                 mograine->SetUInt64Value(UNIT_FIELD_TARGET, lichking->GetGUID());
                 mograine->MonsterSay("Quikly... Run away with Tirion to the portal. I can't channeled him much longer. I stay here and finish the lich king...",LANG_UNIVERSAL,NULL); 
                 lichking->SetStandState(UNIT_STAND_STATE_STAND);
                 ++Phase;
                 Phasetim = 4000;
                 break;
             case 83:
                 lichking->CastSpell(lichking,SPELL_FURY_LK ,false); //don't work! Lich king kill self!
                 ++Phase;
                 Phasetim = 6000;
                 break;
             case 85:
                 lichking->InterruptNonMeleeSpells(false);
                 lichking->setFaction(14);
                 lichking->CastSpell(lichking,35354 ,false); //huck spell
                 ++Phase;
                 Phasetim = 1000;
                 break;
             case 87:
                 lichking->setFaction(35);
                 lichking->SetVisibility(VISIBILITY_OFF);
                 m_creature->SetVisibility(VISIBILITY_OFF);
                 koltira->SetVisibility(VISIBILITY_OFF);
                 mograine->SetVisibility(VISIBILITY_OFF);
                 escort01->SetVisibility(VISIBILITY_OFF);
                 escort02->SetVisibility(VISIBILITY_OFF);
                 escort03->SetVisibility(VISIBILITY_OFF);
                 ++Phase;
                 Phasetim = 300000;
                 break;
             case 89:
                 m_creature->SetVisibility(VISIBILITY_ON);
                 escort01->SetVisibility(VISIBILITY_ON);
                 escort02->SetVisibility(VISIBILITY_ON);
                 escort03->SetVisibility(VISIBILITY_ON);
                 m_creature->SetStandState(UNIT_STAND_STATE_STAND);
                 escort01->SetStandState(UNIT_STAND_STATE_STAND);
                 escort02->SetStandState(UNIT_STAND_STATE_STAND);
                 escort03->SetStandState(UNIT_STAND_STATE_STAND);
                 m_creature->SetUInt32Value(UNIT_VIRTUAL_ITEM_SLOT_ID + 0, uint32(0));
                 ++Phase;
                 Phasetim = 1000;
                 break;                 
             case 91:
                 escort01->DealDamage(escort01, escort01->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 escort02->DealDamage(escort02, escort02->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 escort03->DealDamage(escort03, escort03->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 m_creature->DealDamage(m_creature, m_creature->GetMaxHealth(),NULL, DIRECT_DAMAGE, SPELL_SCHOOL_MASK_NORMAL, NULL, false);
                 ++Phase;
                 Phasetim = 6000;
                 break;
                
            }
     
           if (Phasetim <= diff)
	   {
		   ++Phase;
		   Phasetim = 20000000;
	   } Phasetim -= diff;

      }
  };

CreatureAI* GetAI_npc_tirionTG(Creature *_Creature)
{
    npc_tirionTGAI* tirionTGAI = new npc_tirionTGAI(_Creature);
    return (CreatureAI*)tirionTGAI;
};

struct MANGOS_DLL_DECL npc_monahTGAI : public ScriptedAI
{
   npc_monahTGAI(Creature *c) : ScriptedAI(c) {Reset();
}

bool Tirion_Event;
uint32 Phase;
uint32 Phasetim;

  void Reset() 
   {
     Tirion_Event = false;
     Phase = 1;
     Phasetim = 1000;
     m_creature->SetStandState(UNIT_STAND_STATE_KNEEL);
    }

    void AttackStart(Unit* who)
    {
        if (!who)
            return;

        if (who == m_creature)
            return;

        if (m_creature->Attack(who, true))
        {
            m_creature->AddThreat(who, 0.0f);
            m_creature->SetInCombatWith(who);
            who->SetInCombatWith(m_creature);
            DoStartMovement(who);
        }
    }

    void MoveInLineOfSight(Unit* who)
    {
        if (!who)
            return;

        if (who->isTargetableForAttack() && m_creature->IsHostileTo(who))
            if (m_creature->IsWithinDistInMap(who, 20) && m_creature->IsWithinLOSInMap(who))
                AttackStart(who);
    }

void UpdateAI(const uint32 diff)
   {
     DoMeleeAttackIfReady();

         if (Creature* pTirion = GetClosestCreatureWithEntry(m_creature, NPC_TIRION_FORDRING, 150.0f)) 
              {
                if(((npc_tirionTGAI*)pTirion->AI())->TirionDown == true)
                   {
                    switch(Phase)
                          {
                            case 1:
                                   m_creature->SetStandState(UNIT_STAND_STATE_STAND);
                                   m_creature->RemoveMonsterMoveFlag(MONSTER_MOVE_WALK);
                                   m_creature->GetMotionMaster()->MovePoint(0, pTirion->GetPositionX(), pTirion->GetPositionY(),573.914f);
                                   ++Phase;
		           Phasetim = 2000;
                                   break;
                         }

                      if(Tirion_Event == false)
                        {
                          if (m_creature->GetDistance2d(pTirion) < 18)
                            {
                              m_creature->GetMotionMaster()->Clear(false);
                              m_creature->GetMotionMaster()->MoveIdle();
                              m_creature->StopMoving();
                              m_creature->SetUInt32Value(UNIT_NPC_EMOTESTATE, EMOTE_STATE_READYUNARMED);
                              Tirion_Event = true;
                            } else return;
                        }
                    } else return;
                } else return;

           if (Phasetim <= diff)
	   {
		   ++Phase;
		   Phasetim = 20000000;
	   } Phasetim -= diff;
   }
};

CreatureAI* GetAI_npc_monahTG(Creature *_Creature)
{
    npc_monahTGAI* monahTGAI = new npc_monahTGAI(_Creature);
    return (CreatureAI*)monahTGAI;
};

struct MANGOS_DLL_DECL npc_ebon_knightAI : public ScriptedAI
{
   npc_ebon_knightAI(Creature *c) : ScriptedAI(c) {Reset();
}

uint32 Blood_Timer;
uint32 Death_Timer;
uint32 Frost_Timer;
uint32 HZ_Timer;

  void Reset() 
   {
Blood_Timer = 5000;
Death_Timer = 1000;
Frost_Timer = 12000;
HZ_Timer = 7000;
    }

    void AttackStart(Unit* who)
    {
        if (!who)
            return;

        if (who == m_creature)
            return;

        if (m_creature->Attack(who, true))
        {
            m_creature->AddThreat(who, 0.0f);
            m_creature->SetInCombatWith(who);
            who->SetInCombatWith(m_creature);
            DoStartMovement(who);
        }
    }

    void MoveInLineOfSight(Unit* who)
    {
        if (!who)
            return;

        if (who->isTargetableForAttack() && m_creature->IsHostileTo(who))
            if (m_creature->IsWithinDistInMap(who, 20) && m_creature->IsWithinLOSInMap(who))
                AttackStart(who);
    }

void UpdateAI(const uint32 diff)
   {
        if (!m_creature->SelectHostilTarget() || !m_creature->getVictim())
            return;

     DoMeleeAttackIfReady();

if (Blood_Timer < diff)
        {
            if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(target, 52374);

            Blood_Timer = 5000 + rand()%10000;
        }else Blood_Timer -= diff;

if (Death_Timer < diff)
        {
            if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(target, 57602);

            Death_Timer = 9300;
        }else Death_Timer -= diff;

if (Frost_Timer < diff)
        {
             if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(target, 52375);

            Frost_Timer = 15000 + rand()%10000;
        }else Frost_Timer -= diff;

if (HZ_Timer < diff)
        {
             if (Unit* target = SelectUnit(SELECT_TARGET_RANDOM,0))
                DoCast(target, 52372);

            HZ_Timer = 11000 + rand()%9000;
        }else HZ_Timer -= diff;

  }
};

CreatureAI* GetAI_npc_ebon_knight(Creature *_Creature)
{
    npc_ebon_knightAI* ebon_knightAI = new npc_ebon_knightAI(_Creature);
    return (CreatureAI*)ebon_knightAI;
};

bool GossipHello_npc_tirionTG(Player *player, Creature *_Creature)
{
            if (_Creature->isQuestGiver())
        player->PrepareQuestMenu( _Creature->GetGUID());

            if (player->GetQuestStatus(13364) == QUEST_STATUS_INCOMPLETE)

            if(((npc_tirionTGAI*)_Creature->AI())->Start_Event == false)
      player->ADD_GOSSIP_ITEM(0, "I am ready Highlord.", GOSSIP_SENDER_MAIN, GOSSIP_ACTION_INFO_DEF+2);

    player->PlayerTalkClass->SendGossipMenu(907,_Creature->GetGUID());
    return true;
}

bool GossipSelect_npc_tirionTG(Player *player, Creature *_Creature, uint32 sender, uint32 action )
{
    if(action == GOSSIP_ACTION_INFO_DEF+2)
    {
        ((npc_tirionTGAI*)_Creature->AI())->Start_Event = true;
        ((npc_tirionTGAI*)_Creature->AI())->Hero_Faction = player;
		
        player->CLOSE_GOSSIP_MENU();

    }
    return true;
}

bool GOHello_escape_portal(Player* pPlayer, GameObject* pGo)
{       
    pPlayer->TeleportTo(pPlayer->GetMapId(), 6445.204, 409.518, 495.632, 2.765, false);
    return false;
};

void AddSC_icecrown()
{
    Script *newscript;

    newscript = new Script;
    newscript->Name = "npc_arete";
    newscript->pGossipHello = &GossipHello_npc_arete;
    newscript->pGossipSelect = &GossipSelect_npc_arete;
    newscript->RegisterSelf();

    newscript = new Script;
    newscript->Name = "go_horn";
    newscript->pGOHello = &GOHello_horn;
    newscript->RegisterSelf();

    newscript = new Script;
    newscript->Name = "npc_vardmadra";
    newscript->GetAI = &GetAI_npc_vardmadra;
    newscript->RegisterSelf();

    newscript = new Script;
    newscript->Name = "npc_balargarde";
    newscript->GetAI = &GetAI_npc_balargarde;
    newscript->RegisterSelf();

    newscript = new Script;
    newscript->Name = "npc_tirionTG";
    newscript->GetAI = &GetAI_npc_tirionTG;
    newscript->pGossipHello = &GossipHello_npc_tirionTG;
    newscript->pGossipSelect = &GossipSelect_npc_tirionTG;
    newscript->RegisterSelf();

    newscript = new Script;
    newscript->Name = "npc_monahTG";
    newscript->GetAI = &GetAI_npc_monahTG;
    newscript->RegisterSelf();

    newscript = new Script;
    newscript->Name = "npc_ebon_knight";
    newscript->GetAI = &GetAI_npc_ebon_knight;
    newscript->RegisterSelf();

    newscript = new Script;
    newscript->Name = "go_escape_portal";
    newscript->pGOHello = &GOHello_escape_portal;
    newscript->RegisterSelf();
}
